unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, Menus, ShellApi;

const
    WM_DELAPPBAR = WM_APP + 1024;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MenuWindows: TMenuItem;
    MenuClearner: TMenuItem;
    MenuSpecial: TMenuItem;
    MenuTrash: TMenuItem;
    MenuTemp: TMenuItem;
    MenuRecentFiles: TMenuItem;
    MenuQuit: TMenuItem;
    MenuReboot: TMenuItem;
    MenuLogOff: TMenuItem;
    MenuShutDown: TMenuItem;
    MenuAboutthisWindows: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);
    procedure MenuTrashClick(Sender: TObject);
    procedure MenuRecentFilesClick(Sender: TObject);
    procedure MenuAboutthisWindowsClick(Sender: TObject);
    procedure MenuShutDownClick(Sender: TObject);
  private

  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDELAPPBAR(var Msg: TMessage); message WM_DELAPPBAR;
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    pcinfo, netinfo, util;

{$R *.dfm}

//=============================================================================
//  TAppBarData \̑֐
//=============================================================================

//  O[oϐłȂƑʖڂłBR͒m܂B
var
    AppBarInfo: TAppBarData;

//-----------------------------------------------------------------------------
//  AvP[Vo[̃TCYƈʒu咣
procedure RequestAppBarPos();
begin
    //  L̈ݒ肷
    AppBarInfo.rc := Rect(0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYMENU));
end;
//-----------------------------------------------------------------------------
//  AvP[Vo[̃TCYƈʒuɉeCxgI
procedure AppBarPosChanged();
var
    R: TRect;
begin
    //  L̈ݒ肷
    RequestAppBarPos();
    //  gpł̈VXeɖ₢킹
    SHAppBarMessage(ABM_QUERYPOS, AppBarInfo);
    //  AvP[Vo[̈ʒu𒲐߂
    AppBarInfo.rc.Bottom := AppBarInfo.rc.Top + GetSystemMetrics(SM_CYMENU);
    //  VXeɐVAvP[Vo[̈ʒuʒm
    SHAppBarMessage(ABM_SETPOS, AppBarInfo);
    //  AvP[Vo[wʒuɈړ
    R := AppBarInfo.rc;
    MoveWindow(AppBarInfo.hWnd, R.Left, R.Top, R.Right - R.Left, R.Bottom - R.Top, true);
end;

//=============================================================================
//  AvP[Vo[ɂȂ邽߂̏
//=============================================================================

//-----------------------------------------------------------------------------
//  X^Cݒ
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    //  WS_EX_TOOLWINDOW  WS_POPUP K{̂悤łB
    Params.ExStyle := WS_EX_TOOLWINDOW;
    Params.Style := WS_POPUP;// or WS_CLIPCHILDREN;
end;
//-----------------------------------------------------------------------------
//  AvP[Vo[ɉeCxg󂯂Ƃ
procedure TMainForm.WMDELAPPBAR(var Msg: TMessage);
begin
    case Msg.WParam of
    //  ʂtXN[[h
    ABN_FULLSCREENAPP:
        begin
        end;
    //  AvP[Vo[̃TCYƈʒuɉeCxg
    ABN_POSCHANGED:
        begin
            AppBarPosChanged();
        end;
    //
    ABN_STATECHANGE:
        begin
        end;
    //
    ABN_WINDOWARRANGE:
        begin
        end;
    end;
end;
//-----------------------------------------------------------------------------
//  tH[NGCg
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  LvV\Ȃ
    Self.BorderStyle := bsNone;

    //  \̂ɃAvP[Vo[̃nhݒ
    AppBarInfo.hWnd := Self.Handle;
    //  AvP[Vo[o^
    SHAppBarMessage(ABM_NEW, AppBarInfo);
    //  AvP[Vo[̈ʒu
    AppBarPosChanged();
end;
//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    AppBarInfo.cbSize := SizeOf(AppBarInfo);
    AppBarInfo.hWnd := Self.Handle;
    AppBarInfo.lParam := 0;
    //  AvP[Vo[̓o^
    SHAppBarMessage(ABM_REMOVE, AppBarInfo);
end;
//-----------------------------------------------------------------------------
//  tH[ANeBuɂȂƂ
procedure TMainForm.FormActivate(Sender: TObject);
begin
    //  AvP[Vo[ANeBuɂ
    SHAppBarMessage(ABM_ACTIVATE, AppBarInfo)
end;

//=============================================================================
//  j[
//=============================================================================

//-----------------------------------------------------------------------------
//  I
procedure TMainForm.MenuQuitClick(Sender: TObject);
begin
    Close();
end;
//-----------------------------------------------------------------------------
//  ̃Rs[^ɂĂ̏
procedure TMainForm.MenuAboutthisWindowsClick(Sender: TObject);
begin
    ShowMessage('̃Rs[^ɂĂ̏\\łB');
end;
//-----------------------------------------------------------------------------
//  S~NA
procedure TMainForm.MenuTrashClick(Sender: TObject);
begin
    ClearTrash(Self.Handle);
end;
//-----------------------------------------------------------------------------
//  ꎞtH_t@C폜
procedure TMainForm.MenuRecentFilesClick(Sender: TObject);
var
    Target: string;
begin
    //  ƑΏۂ̃tH_m
    if (Sender = MenuRecentFiles) then
        Target := GetSpecialFolderPath(sfRecent)

    else if (Sender = MenuTemp) then
        Target := GetTempDir()

    else
        Target := '';

    //  s
    if (Target <> '') then
    begin
        ShowMessage(Target + ' ̒gNA\łB');
    end;
end;
//-----------------------------------------------------------------------------
//  OItȂ
procedure TMainForm.MenuShutDownClick(Sender: TObject);
begin
    if (Sender = MenuLogOff) then
        ShowMessage('OIt\łB')

    else if (Sender = MenuReboot) then
        ShowMessage('ċN\łB')

    else if (Sender = MenuShutDown) then
        ShowMessage('Vbg_E\łB')

    else
        ;
end;













//=============================================================================
//  EI
//=============================================================================

initialization
    //  Ô߃[NAĂ
    FillChar(AppBarInfo, SizeOf(AppBarInfo), 0);
    //  ̍ڂZbg(ǂݒ肷ׂ͊ێʂ)
    //  \̂̃TCYݒ
    AppBarInfo.cbSize := SizeOf(AppBarInfo);
    //  Vӂɕ\^Cv
    AppBarInfo.uEdge := ABE_TOP;
    //  L̈ݒ肷
    RequestAppBarPos();
    //  R[obNp̃bZ[W
    AppBarInfo.uCallbackMessage := WM_DELAPPBAR;
end.

