//  ===========================================================================
//  lbg[N֌W̏擾
//  ===========================================================================

unit netinfo;

interface

uses
    Windows, SysUtils;

function GetUserName(): string;
function GetComputerName(): string;
function GetComputerNameEx(): string;

implementation

uses
    UndefinedApi;

//  ===========================================================================
//  [U擾
//  ===========================================================================

function GetUserName(): string;
var
    Buf: array[0..UNLEN] of char;
    Len: Cardinal;
begin
    Len := SizeOf(Buf);
    if (Windows.GetUserName(Buf, Len)) then
    begin
        Result := Buf;
    end
    else
    begin
        Result := SysErrorMessage(GetLastError);
    end;
end;

//  ===========================================================================
//  [JRs[^ NetBIOS 擾
//  ===========================================================================

function GetComputerName(): string;
var
    Buf: array[0..MAX_COMPUTERNAME_LENGTH] of char;
    Len: Cardinal;
begin
    Len := SizeOf(Buf);
    if (Windows.GetComputerName(Buf, Len)) then
    begin
        Result := Buf;
    end
    else
    begin
        Result := SysErrorMessage(GetLastError);
    end;
end;

//  ===========================================================================
//  [JRs[^ NetBIOS ܂ DNS 擾܂
//  Windows NT/2000FWindows 2000
//  Windows 95/98FΉĂ܂
//  ===========================================================================

function GetComputerNameEx(): string;

    function Get_ComputerNameEx(NameType: COMPUTER_NAME_FORMAT): string;
    var
        Buf: string;
        Len: Cardinal;
    begin
        //  obt@̃TCY肵
        Len := 0;
        if (UndefinedApi.GetComputerNameEx(NameType, nil, Len)) then
        begin
            //  obt@p
            SetLength(Buf, Len + 1);
            //  ۂ̎s
            if (UndefinedApi.GetComputerNameEx(NameType, @Buf[1], Len)) then
            begin
                Result := Buf;
            end
            else
            begin
                Result := SysErrorMessage(GetLastError);
            end;
        end
        else
        begin
            Result := SysErrorMessage(GetLastError);
        end;
    end;

begin
    Result :=  'NetBIOS       ' + Get_ComputerNameEx(ComputerNameNetBIOS)
    + #13#10 + 'DNSzXg     ' + Get_ComputerNameEx(ComputerNameDnsHostname)
    + #13#10 + 'DNShC   ' + Get_ComputerNameEx(ComputerNameDnsDomain)
    + #13#10 + 'SCDNS   ' + Get_ComputerNameEx(ComputerNameDnsFullyQualified)
    + #13#10 + 'NetBIOS       ' + Get_ComputerNameEx(ComputerNamePhysicalNetBIOS)
    + #13#10 + 'DNSzXg     ' + Get_ComputerNameEx(ComputerNamePhysicalDnsHostname)
    + #13#10 + 'DNShC   ' + Get_ComputerNameEx(ComputerNamePhysicalDnsDomain)
    + #13#10 + 'SCDNS   ' + Get_ComputerNameEx(ComputerNamePhysicalDnsFullyQualified)
    + #13#10 + 'ComputerNameMax ' + Get_ComputerNameEx(ComputerNameMax)
    ;
end;

end.

