//  ===========================================================================
//  낢
//  ===========================================================================

unit util;

interface

uses
    Windows, SysUtils, ShlObj, ActiveX, ShellApi, UnDefinedApi;

type
    TSpecialFolder = (
        sfDesktop, sfProgram, sfControls, sfPrinters, sfPersonal{, sfFovorites}
        , sfStarup, sfRecent, sfSendTo, sfBitBucket, sfStartMenu
        , sfDesktopDirectory, sfDrive, sfNetWork, sfNetHood, sfFonts
        {, sfTemplete}, sfAppData, sfPrintHood
    );

procedure ClearTrash(hWnd: HWND);
function GetTempDir(): string;
function GetSpecialFolderPath(nFolder: TSpecialFolder):string;

function GetWindowsDirectory(): string;
function GetFileVersion(const FileName: string): string;

function B2KB(const inByte: Int64): string;

implementation

//  ===========================================================================
//  WindowsfBNg̎擾
//  ===========================================================================
function GetWindowsDirectory(): string;
var
    PBuf: PChar;
begin
    GetMem(PBuf, MAX_PATH + 1);
    Windows.GetWindowsDirectory(PBuf, MAX_PATH + 1);
    Result := PBuf;
    FreeMem(PBuf);
end;

//  ===========================================================================
//  TempfBNg̎擾
//  ===========================================================================
function GetTempDir(): string;
var
    PBuf: PChar;
begin
    GetMem(PBuf, MAX_PATH + 1);
    GetTempPath(MAX_PATH + 1, PBuf);
    Result := PBuf;
    FreeMem(PBuf);
end;

//  ===========================================================================
//  t@Co[W̎擾
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=27#0226.txt
//  ===========================================================================
function GetFileVersion(const FileName: string): string;
const
    Translation = '\VarFileInfo\Translation';
    FileInfo = '\StringFileInfo\%0.4s%0.4s\';
var
    BufSize, HWnd: DWORD;
    VerInfoBuf: Pointer;
    VerData: Pointer;
    VerDataLen: Longword;
    PathLocale: String;
begin
    Result := '';
    // Kvȃobt@̃TCY擾
    BufSize := GetFileVersionInfoSize(PChar(FileName), HWnd);
    if BufSize <> 0 then
    begin
        // m
        GetMem(VerInfoBuf, BufSize);
        try
            GetFileVersionInfo(PChar(FileName), 0, BufSize, VerInfoBuf);
            // ϐubN̕ϊe[uw
            VerQueryValue(VerInfoBuf, PChar(Translation), VerData, VerDataLen);
            if (VerDataLen > 0) then
            begin
                // 816iɕϊ
                // '\StringFileInfo\027382\FileDescription'
                PathLocale := Format(FileInfo + 'FileVersion',
                [IntToHex(Integer(VerData^) and $FFFF, 4),
                IntToHex((Integer(VerData^) shr 16) and $FFFF, 4)]);
                VerQueryValue(VerInfoBuf, PChar(PathLocale), VerData, VerDataLen);
                if VerDataLen > 0 then
                begin
                    // VerData̓[ŏI镶ł͂ȂƂɒ
                    SetLength(result, VerDataLen);
                    StrLCopy(PChar(result), VerData, VerDataLen);
                end;
            end;
        finally
            // 
            FreeMem(VerInfoBuf);
        end;
    end;
end;

//  ===========================================================================
//  oCgLoCg
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#getmemory
//  ===========================================================================
function B2KB(const inByte: Int64): string;
begin
    Result := FormatFloat('#,##0 KB', Round(inByte / 1024));
end;

//-----------------------------------------------------------------------------
//  S~ɂ
//-----------------------------------------------------------------------------
//  http://www.google.co.jp/search?hl=ja&inlang=ja&q=SHEmptyRecycleBin&lr=lang_ja
//  http://homepage1.nifty.com/MADIA/delphi/Win32API/RecycleBin.htm
procedure ClearTrash(hWnd: HWND);
begin
    SHEmptyRecycleBin(hWnd, '', 0);
end;

//-----------------------------------------------------------------------------
//  etH_̃pX擾
//-----------------------------------------------------------------------------
//  http://homepage1.nifty.com/MADIA/delphi/Win32API/ShFolder.htm
//  http://homepage2.nifty.com/Mr_XRAY/Delphi/plFileDialog/B_BrowseFolder.htm
const
    SpecialFolderID: array[TSpecialFolder] of integer =
    (
        CSIDL_DESKTOP, CSIDL_PROGRAMS, CSIDL_CONTROLS, CSIDL_PRINTERS
        , CSIDL_PERSONAL{, CSIDL_FOVORITES}, CSIDL_STARTUP, CSIDL_RECENT
        , CSIDL_SENDTO, CSIDL_BITBUCKET, CSIDL_STARTMENU, CSIDL_DESKTOPDIRECTORY
        , CSIDL_DRIVES, CSIDL_NETWORK, CSIDL_NETHOOD, CSIDL_FONTS{, CSIDL_TEMPLATE}
        , CSIDL_APPDATA, CSIDL_PRINTHOOD
    );

function GetSpecialFolderPath(nFolder: TSpecialFolder):string;
var
    Root : PItemIDList;
    Buffer: PChar;
    Memory: IMalloc;
begin
    SHGetMalloc(Memory);
    Buffer := Memory.Alloc(MAX_PATH);
    //  tH_̈ʒu擾
    SHGetSpecialFolderLocation(0, SpecialFolderID[nFolder], Root);
    //  ItemIDList\̂pXo
    SHGetPathFromIDList(Root, Buffer);
    Result := Buffer;
    //  ̉
    Memory.Free(Root);
    Memory.Free(Buffer);
end;

end.

